const {app, BrowserWindow, Menu, MenuItem, session, net, ipcMain, Tray, globalShortcut} = require('electron')
const fs = require('fs');
const iconv = require('iconv-lite');
const settings = require('electron-settings');
const {spawn} = require('child_process')

iconv.skipDecodeWarning = true;

const template = [
    {
        label: '设置',
        submenu: [
            { role: 'reload', label: '重新加载' },
            { role: 'forcereload', label: '强制更新'  },
            // { role: 'toggledevtools' },
            { type: 'separator' },
            // { role: 'zoomout', label: '放大' },
            // { role: 'zoomin', label: '缩小' },
            // { role: 'resetzoom', label: '还原' },
            // { type: 'separator' },
            { role: 'togglefullscreen', label: '全屏显示' }
        ]
    },
    {
        label: '编辑',
        submenu: [
            // { role: 'undo' },
            // { role: 'redo' },
            // { type: 'separator' },
            { role: 'cut', label: '剪切' },
            { role: 'copy', label: '复制' },
            { role: 'paste', label: '粘贴' },
            // { role: 'pasteandmatchstyle' },
            // { role: 'delete' },
            // { role: 'selectall' }
        ]
    },
    {
        role: 'window',
		label: '窗口',
        submenu: [
            { role: 'minimize', label: '最小化'  },
            { role: 'close', label: '关闭'  }
        ]
    }
]

let mainWindow
// const WATCH_TARGET = './股票池.tx';
// const WATCH_TARGET = './StockBlock.ini';
var watch_id_map = {}

function createWindow () {
    app.setName('打板神器')
    // mainWindow = new BrowserWindow({width: 1280, height: 800})
	// const appIcon = new Tray('app/assets/app-icon/windows/app.ico')
    mainWindow = new BrowserWindow({
        webPreferences: {
            nodeIntegration: true
        },
		icon: 'resources/app/assets/app-icon/windows/app.ico',
    })
    mainWindow.hide()
    mainWindow.webContents.on('did-finish-load', () => {
        mainWindow.show()
    })

    /*
    template[0].submenu.push(
        { type: 'separator' },
        {
            label: '调试工具',
            accelerator: 'CmdOrCtrl+I',
            click: () => { mainWindow.webContents.openDevTools() }
        }
    )
    */


    if (process.platform === 'darwin') {
        template.unshift({
            label: app.getName(),
            submenu: [
                { role: 'about' },
                { type: 'separator' },
                { role: 'services' },
                { type: 'separator' },
                { role: 'hide' },
                { role: 'hideothers' },
                { role: 'unhide' },
                { type: 'separator' },
                { role: 'quit' }
            ]
        })
    }
    const menu = Menu.buildFromTemplate(template)
    Menu.setApplicationMenu(menu)

    // mainWindow.loadFile('index.html')
    // win.loadURL(path.join('file://', __dirname, '/dashboard/index.html'));
    mainWindow.loadURL(`http://heheapp.com/index.html`);
    // mainWindow.webContents.openDevTools()

	let strat_ws_cmd
	if ( process.platform == 'win32' ) {
		let port = parseInt(Math.random() * 1000)
		try {
			if (false) {
				strat_ws_cmd = spawn('ws/ws.exe', [port], {detached: false})
				console.log(port);
				strat_ws_cmd.stdout.on('data', (data) => {
					console.log(data.toString());
				})
				strat_ws_cmd.stderr.on('data', (data) => {
					console.log(data.toString());
				})
				strat_ws_cmd.on('exit', (code) => {
					console.log(`exit ${code}`);
				})
			}
		} catch (e) {

		} finally {

		}
		ipcMain.on('get-ws-port', (event, arg) => {
		    event.returnValue = {
				'port': 13000 + port
			}
		})
	} else {
		ipcMain.on('get-ws-port', (event, arg) => {
		    event.returnValue = {
				'port': 13000
			}
		})
	}

    mainWindow.on('closed', function () {
        mainWindow = null
		if ( process.platform == 'win32' && false ) {
			// strat_ws_cmd.kill('SIGTERM')
			// strat_ws_cmd.kill('SIGINT')
            spawn('taskkill', ['/F', '/IM', 'ws.exe', '/T'], {detached: true})
			// process.kill(-strat_ws_cmd.pid)
		}
    })
    mainWindow.maximize()

	globalShortcut.register('CommandOrControl+F', () => {
		mainWindow.webContents.send('on-find');
	});
    /*
	mainWindow.webContents.executeJavaScript("$(document).ready(function() { window.localStorage.setItem('ngStorage-app_type_version', '\"plus\"'); window.localStorage.setItem('ngStorage-apiHost', '\"api-1.heheapp.com\"');})").then(function(value){});
	mainWindow.webContents.on('did-finish-load', () => {
		mainWindow.webContents.executeJavaScript("window.localStorage.setItem('ngStorage-app_type_version', '\"plus\"')").then(function(value){});
		mainWindow.webContents.executeJavaScript("window.localStorage.setItem('ngStorage-apiHost', '\"api-1.heheapp.com\"')").then(function(value){});
	})
    */

	var stock_pool_settings = settings.get('stock_pool_settings')
	if ( stock_pool_settings != undefined ) {
		for (var pool_name in stock_pool_settings) {
			var item = stock_pool_settings[pool_name]
			var path = item['path']
			var block_type = item['block_type']
			if ( path != undefined ) {
				var exists = fs.existsSync(path)
				if (exists) {
					// console.log(item);
					// console.log(pool_name);
					watch_id_map[pool_name] = startWatch(path, block_type, pool_name)
				}
		        // fs.exists(path, function(exists) {
				// 	console.log(item);
				// 	console.log(pool_name);
		        // 	if (exists) {
		        // 		watch_id_map[pool_name] = startWatch(path, block_type, pool_name)
		        // 	}
		        // })
		    }
		}
	}
}

ipcMain.on('stock-block-settings', (event, arg) => {
	console.log(arg);
    settings.set('stock_pool_settings.' + arg['pool_name'], {
        block_type: arg['type'],
        path: arg['path'],
        plate: arg['plate'],
		pool_name: arg['pool_name']
    });
    if ( arg['type'] == 'tdx' ) {
        readCodes(arg['path'], arg['pool_name'])
    } else if ( arg['type'] == '10jqka' ) {
        readCodes_10jqka(arg['path'], arg['pool_name'])
    }
	var watch_id = watch_id_map[arg['pool_name']]
    if ( watch_id ) {
        watch_id.close()
    }
    watch_id_map[arg['pool_name']] = startWatch(arg['path'], arg['type'], arg['pool_name'])
	event.returnValue = {
		'success': true
	}
})

ipcMain.on('stock-block-settings-clean', (event, arg) => {
	var pool_name = arg['pool_name']
	var watch_id = watch_id_map[pool_name]
    if ( watch_id ) {
        watch_id.close()
        settings.delete('stock_pool_settings.' + pool_name)
		watch_id_map[pool_name] = false
    }
    sync_codes([], pool_name);
    event.returnValue = {
		'success': true
	}
})

app.commandLine.appendSwitch('autoplay-policy', 'no-user-gesture-required')
app.on('ready', createWindow)

app.on('window-all-closed', function () {
    app.quit()
    /*
    if (process.platform !== 'darwin') {
        app.quit()
    }
    */
})

app.on('activate', function () {
    // On OS X it's common to re-create a window in the app when the
    // dock icon is clicked and there are no other windows open.
    if (mainWindow === null) {
        createWindow()
    }
})


var parseINIString = function (data) {
    var regex = {
        section: /^\s*\[\s*([^\]]*)\s*\]\s*$/,
        param: /^\s*([^=]+?)\s*=\s*(.*?)\s*$/,
        comment: /^\s*;.*$/
    };
    var value = {};
    var lines = data.split(/[\r\n]+/);
    var section = null;
    lines.forEach(function(line){
        if (regex.comment.test(line)) {
            return;
        } else if (regex.param.test(line)) {
            var match = line.match(regex.param);
            if (section) {
                value[section][match[1]] = match[2];
            } else {
                value[match[1]] = match[2];
            }
        } else if (regex.section.test(line)) {
            var match = line.match(regex.section);
            value[match[1]] = {};
            section = match[1];
        } else if (line.length == 0 && section) {
            section = null;
        };
    });
    return value;
}

var sync_codes = function(codes, pool_name) {
    console.log(codes);
    session.defaultSession.cookies.get({url: 'http://heheapp.com', name: 'token'}, (error, cookies) => {
        var token = ''
        cookies.forEach(function(v) {
            if ( v.name == 'token' ) {
                token = v.value
            }
        })
        console.log(token)
        const request = net.request({
            url: 'http://api.heheapp.com/api/users_spool?name=' + pool_name,
            method: 'PUT'
        })
        request.setHeader('Authorization', 'Bearer ' + token)
        request.setHeader('Content-Type', 'application/json')
        request.on('response', (response) => {
            console.log(`STATUS: ${response.statusCode}`)
            console.log(`HEADERS: ${JSON.stringify(response.headers)}`)
            response.on('data', (chunk) => {
                console.log(`BODY: ${chunk}`)
            })
            response.on('end', () => {
                console.log('No more data in response.')
            })
        })
        request.end(JSON.stringify({codes: codes}))
    })
}

function readCodes_10jqka(path, pool_name) {
    var plate_id = settings.get('stock_pool_settings.' + pool_name + '.plate')
    if ( path == undefined || plate_id == undefined ) {
        return
    }
    fs.readFile(path, {encoding:'binary'}, function(err, data) {
		if (err) {
			console.log(err);
		} else {
            var ini_data = parseINIString(iconv.decode(data, 'GBK'))
            var plate_raw_data = ini_data['BLOCK_STOCK_CONTEXT'][plate_id]
            var codes = []
            if ( plate_raw_data ) {
                var raw_codes = plate_raw_data.split(",");
                raw_codes.forEach(function(v){
                    var code_info = v.split(":");
                    if ( code_info[0] == '33' || code_info[0] == '17' ) {
                        codes.push(code_info[1])
                    }
                })
            }
			sync_codes(codes, pool_name)
		}
	})
}

function readCodes(path, pool_name) {
    if ( path == undefined ) {
        return
    }
	fs.readFile(path, function(err, data) {
		if (err) {
			console.log(err);
		} else {
			var _codes = data.toString().split("\n");
			var codes = []
			_codes.forEach(function(v) {
				var c = v.replace(/\\r/,'').replace(/^\s+|\s+$/gm,'');
				if ( c.substr(0, 1) == '0' || c.substr(0, 1) == '1' ) {
					codes.push(c.substr(1, 6))
				}
			})
			sync_codes(codes, pool_name)
		}
	})
}

function startWatch(path, block_type, pool_name) {
    if ( path == undefined ){
        return false;
    }
	return fs.watch(path, (eventType) => {
		if (eventType == 'change') {
            if ( block_type == 'tdx' ) {
                readCodes(path, pool_name)
            } else if ( block_type == '10jqka' ) {
                readCodes_10jqka(path, pool_name)
            }
		}
	});
}
